'''
Created on 27/04/2009

@author: ben
'''

from euclid import *
from misc import *
        
class InteractionArea:
    def __init__(self,x=100,y=100,r=20,dir=None,id=None):
        self.x = x
        self.y = y
        self.r = r
        self.dir = dir
        self.id = id

class MapData(object):
    # scene annotations
    # a md.walkArea consists of a list of points of a polygon that defines the walking area
    # an interactionArea is a position on the map, 
    # that includes an optional direction    
    # and a identifier that can be used to run a script
    # an interaction area has a position, radius, and id
    # REMOVED: walkarea layer spec, list of [polygon,index] pairs
    # objects, a list of Bunch(name,position,pivot(offset)...) used to position objects, data is objects specific info
    
    def __init__(self):
        "Create a blank map data"
        self.bgimage = None
        self.walkArea = None
        #self.walkAreaLayerSpecs = []
        self.interactionAreas = []
        self.objects = []
        self.textAreaTransformation = None
    
#===============================================================================
#    # some useful functions
#    def inLayer(self,p):
#        "Returns the layer index corresponding to this coordinate"
#        for [lines,index] in self.walkAreaLayerSpecs:
#            if MapData.insidePoly(lines,(p.x,p.y)): return index
#        return None
#===============================================================================
    
#===============================================================================
#    @staticmethod
#    def insidePoly(lines,(x,y)):                       
#        #do a simple line intersection count to determine if it is inside this polygon
#        line = LineSegment2(Point2(x,y),Point2(0,0))
#        
#        count = 0
#        for i in range(len(lines)):
#            ni = (i+1)%len(lines)
#            p1 = apply(Point2,lines[i])
#            p2 = apply(Point2,lines[ni])
#            polyline = LineSegment2(p1,p2)
#            if line.intersect(polyline):
#                count += 1
#        return count%2==1      
#===============================================================================
    
    def output(self):
        print("bg image:",self.bgimage)
        print("walk area: ",self.walkArea)
        print("interaction areas")
        for ia in self.interactionAreas:
            print(ia.id,ia.x,ia.y,ia.y,ia.dir)
        print "objects"
        for o in self.objects:
            print o.name, o.position, o.pivot, o.img
        