'''
Created on 01/05/2009

@author: ben
'''

from room import (Room,InteractionObject)
from things import (Thing,StaticThing)
import globals

class Bench(InteractionObject):
    def __init__(self,ia):
        super(Bench,self).__init__(ia)
        self.items_left = ["screwdriver","boltcutters"]
        
    def used(self,item):
        InteractionObject.used(self,item)
        gm = globals.game
        pl = globals.player
        
        if len(self.items_left)==0:
            gm.displayText("Bits and pieces, junk really.", 4.0)
        else:
            options = ["take "+i for i in self.items_left]
            gm.query(self,options)       
            
    def notify(self, res):
        gm = globals.game
        pl = globals.player
        
        if res=="take screwdriver":
            gm.displayText("Got screwdriver",2.0)
            pl.addItem("screwdriver")
            self.screwdriver.show = False
            self.items_left.remove("screwdriver")
        elif res=="take boltcutters":
            gm.displayText("Got boltcutters",2.0)
            pl.addItem("boltcutters")
            self.boltcutters.show = False
            self.items_left.remove("boltcutters")
                    
class Hallway(Room):

    def __init__(self):
        super(Hallway,self).__init__("The hallway","hallway.dat")
        
        self.loadAndSortObjects({'vase1':StaticThing('vase1.png'),'vase2':StaticThing('vase2.png'),'secretdoor':StaticThing("secretdoor.png")})
        self.setInteractionZones()
        
        self.secretdoor = self.getObject('secretdoor')
        self.secretPortal = self.getPortal(8)
        
        self.secretdoor.show = False
        self.secretPortal.disabled = True
        
    def openSecretDoor(self):
        self.secretdoor.show = True
        self.secretPortal.disabled = False
          